@using Services;
@using WebCalc.Components.Controls;
@inject ConvertService convertService

<div>
    <EditForm Model="@DummyModel">
        <div class="form-group">
            <h6>Post-Money Valuation = Pre-Money Valuation + Investment Amount</h6>
            <label class="mr-sm-2">Select any 2 (Can select only 2, deselect one to select another)</label>
            <label class="mr-sm-2">Equity + Pre-Money don't work</label>
        </div>
        <div class="form-group">
            <table class="table table-hover table-sm">
                <tbody>
                    <tr>
                        <td>Investment</td>
                        <td>
                            <TextBoxCheckedDouble
                                @bind-Enabled="@EnabledInvestment" @bind-Enabled:event="EnabledChanged"
                                @bind-Value="@Investment" @bind-Value:event="ValueChanged" />
                        </td>
                    </tr>
                    <tr>
                        <td>% Equity</td>
                        <td>
                            <TextBoxCheckedDouble EnableCurrencyConvert=false MaxLength="6"
                                @bind-Enabled="@EnabledEquity" @bind-Enabled:event="EnabledChanged"
                                @bind-Value="@Equity" @bind-Value:event="ValueChanged" />
                        </td>
                    </tr>
                    <tr>
                        <td>Pre-Money Valuation</td>
                        <td>
                            <TextBoxCheckedDouble
                                @bind-Enabled="@EnabledPreMoneyAmount" @bind-Enabled:event="EnabledChanged"
                                @bind-Value="@PreMoneyAmount" @bind-Value:event="ValueChanged" />
                        </td>
                    </tr>
                    <tr>
                        <td>Post-Money Valuation</td>
                        <td>
                            <TextBoxCheckedDouble
                                @bind-Enabled="@EnabledPostMoneyAmount" @bind-Enabled:event="EnabledChanged"
                                @bind-Value="@PostMoneyAmount" @bind-Value:event="ValueChanged" />
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </EditForm>
</div>

@code {

    private string DummyModel { get; set; } = string.Empty;

    private bool EnabledInvestment { get; set; } = false;
    private double Investment { get; set; } = 0;
    private bool EnabledEquity { get; set; } = false;
    private double Equity { get; set; } = 0;
    private bool EnabledPreMoneyAmount { get; set; } = false;
    private double PreMoneyAmount { get; set; } = 0;
    private bool EnabledPostMoneyAmount { get; set; } = false;
    private double PostMoneyAmount { get; set; } = 0;

    protected override bool ShouldRender()
    {
        RefreshValues();
        bool shouldRender = base.ShouldRender();
        return shouldRender;
    }

    private double ToDouble(object value) => convertService.ToDouble(value);

    private void RefreshValues()
    {
        int enabledCount = GetEnabledInputCount();
        if (enabledCount >= 2)
        {
            ResetEnabledCount();
            PreFilter();
            Calculate();
        }
        else
        {
            if (!EnabledInvestment) Investment = 0;
            if (!EnabledEquity) Equity = 0;
            if (!EnabledPreMoneyAmount) PreMoneyAmount = 0;
            if (!EnabledPostMoneyAmount) PostMoneyAmount = 0;
        }
    }

    private int GetEnabledInputCount()
    {
        int enabledCount = 0;
        if (EnabledInvestment) enabledCount++;
        if (EnabledEquity) enabledCount++;
        if (EnabledPreMoneyAmount) enabledCount++;
        if (EnabledPostMoneyAmount) enabledCount++;
        return enabledCount;
    }

    private void ResetEnabledCount()
    {
        int enabledCount;
        do
        {
            enabledCount = GetEnabledInputCount();
            if (enabledCount > 2)
            {
                if (EnabledPostMoneyAmount) { EnabledPostMoneyAmount = !EnabledPostMoneyAmount; continue; }
                if (EnabledPreMoneyAmount) { EnabledPreMoneyAmount = !EnabledPreMoneyAmount; continue; }
                if (EnabledEquity) { EnabledEquity = !EnabledEquity; continue; }
                if (EnabledInvestment) { EnabledInvestment = !EnabledInvestment; continue; }
            }
        } while (enabledCount > 2);
    }

    private void PreFilter()
    {
        if (EnabledEquity && Equity < 0)
        {
            Equity = 0;
            PreMoneyAmount = 0;
            PostMoneyAmount = 0;
        }
        if (Equity > 100) Equity = 100;
        if (EnabledInvestment && Investment < 0)
        {
            Investment = 0;
            PreMoneyAmount = 0;
            PostMoneyAmount = 0;
        }
    }

    private void Calculate()
    {
        if (EnabledEquity && Equity == 0) return;
        if (EnabledInvestment && Investment == 0) return;
        // Investment
        if (EnabledInvestment && EnabledEquity)
        {
            PostMoneyAmount = Math.Round((Investment / Equity) * 100, 2);
            PreMoneyAmount = PostMoneyAmount - Investment;
        }
        else if (EnabledInvestment && EnabledPreMoneyAmount)
        {
            PostMoneyAmount = Investment + PreMoneyAmount;
            Equity = Math.Round((Investment / PostMoneyAmount) * 100, 2);
        }
        else if (EnabledInvestment && EnabledPostMoneyAmount)
        {
            PreMoneyAmount = PostMoneyAmount - Investment;
            Equity = Math.Round((Investment / PostMoneyAmount) * 100, 2);
        }
        // Equity
        else if (EnabledEquity && EnabledPreMoneyAmount)
        {
            Investment = 0;
            PostMoneyAmount = 0;
        }
        else if (EnabledEquity && EnabledPostMoneyAmount)
        {
            Investment = Math.Round((PostMoneyAmount * Equity) / 100, 2);
            PreMoneyAmount = PostMoneyAmount - Investment;
        }
        // Pre & Post money
        else if (EnabledPreMoneyAmount && EnabledPostMoneyAmount)
        {
            Investment = PostMoneyAmount - PreMoneyAmount;
            Equity = Math.Round((Investment / PostMoneyAmount) * 100, 2);
        }
        else throw new NotImplementedException("Option not found");
    }

}
